*************************************************************************
*   ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING          *
*   Copyright (C) 1998 Keiichi Ishioka                                  *
*                                                                       *
*   This library is free software; you can redistribute it and/or       *
*   modify it under the terms of the GNU Library General Public         *
*   License as published by the Free Software Foundation; either        *
*   version 2 of the License, or (at your option) any later version.    *
*                                                                       *
*   This library is distributed in the hope that it will be useful,     *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of      *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
*   Library General Public License for more details.                    *
*                                                                       *
*   You should have received a copy of the GNU Library General Public   *
*   License along with this library; if not, write to the Free          *
*   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  *
*************************************************************************
************************************************************************
*     CALCULATE THE POSITION OF A SPECTRUM COEFFICIENT OF P_N^M 95/10/03
*-----------------------------------------------------------------------
*     IF M.GE.0 --> REAL PART
*     IF M.LT.0 --> IMAGINARY PART
************************************************************************
      SUBROUTINE STNM2L(MM,N,M,L)

      IF(M.EQ.0) THEN
        L=N+1
      ELSE IF(M.GT.0) THEN
        L=M*(2*MM-M+2)-MM+N
      ELSE
        L=(-M)*(2*MM-(-M)+2)+N-(-M)+1
      END IF

      END
************************************************************************
      SUBROUTINE STL2NM(MM,L,N,M)

      IF(L.LE.MM+1) THEN
        N=L-1
        M=0
      ELSE
        M=(2*MM+3-SQRT(1D0*((2*MM+3)*(2*MM+3)-4*(L+MM))))/2
        N=M+L-(M*(2*MM-M+3)-MM)
        IF(N.GT.MM) THEN
          N=N-(MM-M+1)
          M=-M
        END IF
      END IF

      END
